﻿@model eCommerce.BackOffice.ViewModels.CreateOrderPaymentViewModel
@using eCommerce.Services.Model.Enums
@{
    ViewBag.Title = "Operaciones Contables";
    Layout = "~/Views/Shared/_ListLayout.cshtml";
}


<div class="page-header">
    <h1 class="page-title">Asiento Contable</h1>
    <ol class="breadcrumb">
        <li class="active">Crear / Editar</li>
    </ol>
</div>

<div class="page-content">
    <div class="panel">
        <div class="panel-body">
            <div class="col-md-12">
                <div id="example">
                    @using (Html.BeginForm("TransactionUpdate", "Transactions", FormMethod.Post, new { @class = "form-horizontal", @autocomplete = "off" }))
                    {
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Fecha:</label>
                            <div class="col-sm-3">
                                <div class="input-group">
                                    <span class="input-group-addon">
                                        <i class="icon wb-calendar" aria-hidden="true"></i>
                                    </span>
                                    <input type="text" class="form-control" name="Payment.Date" value="@(Model.Payment.Date != DateTime.MinValue ? Model.Payment.Date.ToShortDateString() : DateTime.Today.ToShortDateString())" data-plugin="datepicker" />
                                </div>
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Cuenta:</label>
                            <div class="col-sm-4">
                                <select class="form-control" name="Payment.AccountId" id="AccountId" data-plugin="select2">
                                    <option value=""></option>
                                    @if (TempData["Accounts"] != null)
                                    {
                                        foreach (var item in (SelectList)TempData["Accounts"])
                                        {
                                            <option value="@item.Value" selected="@item.Selected">@item.Text</option>
                                        }
                                    }
                                </select>
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Concepto:</label>
                            <div class="col-sm-4">
                                <select class="form-control" name="Payment.TransactionCategoryId" id="TransactionCategoryId" data-plugin="select2">
                                    <option value=""></option>
                                    @if (TempData["Concepts"] != null)
                                    {
                                        foreach (var item in (SelectList)TempData["Concepts"])
                                        {
                                            <option value="@item.Value" selected="@item.Selected">@item.Text</option>
                                        }
                                    }
                                </select>
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Moneda:</label>
                            <div class="col-sm-4">
                                <select class="form-control" name="Payment.CurrencyId" id="CurrencyId" data-plugin="select2">
                                    <option value="@((int)CurrencyEnum.Peso)" selected="@(Model.Payment.CurrencyId == (int)CurrencyEnum.Peso)">Peso</option>
                                    <option value="@((int)CurrencyEnum.Dolar)" selected="@(Model.Payment.CurrencyId == (int)CurrencyEnum.Dolar)">Dolar</option>
                                </select>
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Monto:</label>
                            <div class="col-sm-4">
                                <div class="input-group">
                                    <span class="input-group-addon">$</span>
                                    <input type="text" class="form-control" name="Payment.Amount" placeholder="0,00" value="@(Model.Payment.Amount != 0 ? Model.Payment.Amount.ToString() : string.Empty)">
                                </div>
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="col-sm-2 control-label">Observaciones:</label>
                            <div class="col-sm-9">
                                <textarea class="form-control" name="Payment.Observations" rows="2">@Model.Payment.Observations</textarea>
                            </div>
                        </div>

                        <input type="hidden" name="ChecksIds" id="ChecksIds" value="@Model.ChecksIds" />

                        <div class="row">
                            <div class="col-md-12">
                                <div class="text-right margin-top-20">
                                    <button type="button" class="btn btn-outline btn-primary" data-target="#checks2" data-toggle="modal" id="addCheckButton2">
                                        <i class="icon wb-plus" aria-hidden="true"></i>
                                        <span class="hidden-xs">CHEQUES EN CARTERA</span>
                                    </button>
                                    <button type="button" class="btn btn-outline btn-primary" data-target="#checks" data-toggle="modal" id="addCheckButton">
                                        <i class="icon wb-plus" aria-hidden="true"></i>
                                        <span class="hidden-xs">AGREGAR CHEQUE</span>
                                    </button>
                                </div>
                                <div class="example">
                                    <div class="example-body">
                                        <table class="table table-bordered table-hover" id="newChecksTable">
                                            <thead>
                                                <tr>
                                                    <th class="text-center">N° Int.</th>
                                                    <th class="text-center">Recibido</th>
                                                    <th class="text-center">N° Cheque</th>
                                                    <th class="text-center">Banco</th>
                                                    <th class="text-center">Monto</th>
                                                    <th class="text-center">Vencimiento</th>
                                                    <th></th>
                                                </tr>
                                            </thead>
                                            <tbody>
                                                @{int rowNumber = 0;}
                                                @foreach (var check in Model.Payment.Checks)
                                                {
                                                    <tr class="gradeA check" data-attr-checkId="@check.CheckId">
                                                        <td class="checkId text-center">@check.CheckId</td>
                                                        <td class="receivedDate text-center">@check.RecievedDate.ToShortDateString()</td>
                                                        <td class="checkNumber text-center">@check.Number</td>
                                                        <td class="text-center">@check.Bank.Name</td>
                                                        <td class="checkAmount text-center">$@check.Amount</td>
                                                        <td class="dueDate text-center">@check.DueDate.ToShortDateString()</td>
                                                        <td class="text-center"><i class="icon fa-close removeCheck" aria-hidden="true" data-attr-id="@rowNumber" onclick="removeCheck(this,@rowNumber);"></i></td>
                                                    </tr>
                                                    rowNumber++;
                                                }
                                            </tbody>
                                        </table>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-md-12">
                                <table class="table table-bordered table-hover table-striped" id="totalTable">
                                    <colgroup>
                                        <col class="col-sm-1">
                                        <col class="col-sm-1">
                                        <col class="col-sm-4">
                                        <col class="col-sm-2">
                                        <col class="col-sm-2">
                                        <col class="col-sm-1">
                                    </colgroup>
                                    <thead>
                                        <tr></tr>
                                    </thead>
                                    <tbody></tbody>
                                    <tfoot>
                                        <tr class="active">
                                            <td class="text-right" style="font-weight:bold;" colspan="4">SUMATORIA DE VALORES</td>
                                            <td><span id="cgTotal">0</span></td>
                                        </tr>
                                    </tfoot>
                                </table>
                            </div>
                        </div>

                        <div class="text-right">
                            <button type="submit" class="btn btn-primary btn-success" id="btnSave">Grabar</button>
                            <button type="button" class="btn btn-default" onclick="window.history.back();">Cancelar</button>
                            @Html.HiddenFor(model => Model.Payment.TransactionId)
                        </div>
                    }
                </div>
            </div>
        </div>
    </div>

    <!--MODAL CHEQUES-->
    <div class="modal fade" id="checks" aria-hidden="false" aria-labelledby="exampleFormModalLabel" role="dialog" style="overflow:hidden;">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">×</span>
                    </button>
                    <h4 class="modal-title" id="exampleFormModalLabel">Complete los siguientes datos</h4>
                </div>
                <div class="modal-body">
                    <div class="row">
                        <form id="checksForm">
                            <div class="col-lg-12 form-group">
                                <select class="form-control" id="bankId" name="CheckBank" data-plugin="select2">
                                    <option value=""></option>
                                    @if (Model.Banks != null)
                                    {
                                        foreach (var item in Model.Banks)
                                        {
                                            <option value="@item.Value">@item.Text</option>
                                        }
                                    }
                                </select>
                            </div>
                            <div class="col-lg-6 form-group">
                                <div class="input-group">
                                    <span class="input-group-addon">
                                        <i class="icon wb-calendar" aria-hidden="true"></i>
                                    </span>
                                    <input type="text" class="form-control" name="ReceivedDate" id="checkReceivedDate" data-plugin="datepicker" placeholder="Recibido" />
                                </div>
                            </div>
                            <div class="col-lg-6 form-group">
                                <div class="input-group">
                                    <span class="input-group-addon">
                                        <i class="icon wb-calendar" aria-hidden="true"></i>
                                    </span>
                                    <input type="text" class="form-control" name="CheckDueDate" id="checkDueDate" data-plugin="datepicker" placeholder="Vencimiento" />
                                </div>
                            </div>
                            <div class="col-lg-6 form-group">
                                <input type="text" class="form-control" name="CheckNumber" id="checkNumber" placeholder="Número de Cheque">
                            </div>
                            <div class="col-lg-6 form-group">
                                <div class="input-group">
                                    <span class="input-group-addon">$</span>
                                    <input type="text" class="form-control" name="CheckAmount" id="checkAmount" placeholder="Monto" value="">
                                </div>
                            </div>

                            <div class="col-lg-7 form-group">
                                <select class="form-control" id="checkOwn" name="CheckOwn" data-plugin="select2">
                                    <option value=""></option>
                                    <option value="true">Propio</option>
                                    <option value="false">De Terceros</option>
                                </select>
                            </div>
                            <div class="col-sm-12 text-right">
                                <p>Número de Cheque Interno: <span id="lastCheckId"></span></p>
                            </div>
                            <div class="col-sm-12 text-right">
                                <button class="btn btn-primary btn-outline" @*data-dismiss="modal"*@ id="btnAddCheck">Agregar</button>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- End Modal -->
    <!-- Modal cheques en cartera -->

    <div class="modal fade" id="checks2" aria-hidden="false" aria-labelledby="checks"
         role="dialog" tabindex="-1">
        <div class="modal-dialog" style="width: 800px;">
            <form class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">×</span>
                    </button>
                    <h4 class="modal-title" id="exampleFormModalLabel">Cheques en Cartera</h4>
                </div>
                <div class="modal-body">
                    @{Html.RenderAction("CheckListPartial");}
                    @*@{ Html.RenderPartial("~/Views/Checks/_CheckList.cshtml", Model.Checks); }*@
                </div>
            </form>
        </div>
    </div>
</div>
<!-- End Modal -->
<style type="text/css">
    .select2-close-mask {
        z-index: 2099;
    }

    .select2-dropdown {
        z-index: 3051;
    }
</style>


@section Scripts {

    <script type="text/javascript">

        (function () {
            $('.form-horizontal').formValidation({
                framework: "bootstrap",
                button: {
                    selector: '#btnSave',
                    disabled: 'disabled'
                },
                icon: null,
                fields: {
                    Date: {
                        validators: {
                            notEmpty: {
                                message: 'El campo es requerido.'
                            }
                        }
                    },
                    AccountId: {
                        validators: {
                            notEmpty: {
                                message: 'El campo es requerido.'
                            }
                        }
                    },
                    TransactionCategoryId: {
                        validators: {
                            notEmpty: {
                                message: 'El campo es requerido.'
                            }
                        }
                    },
                    Amount: {
                        validators: {
                            notEmpty: {
                                message: 'El campo es requerido.'
                            }
                        }
                    }

                }
            });
        })();

        $('#checksForm').formValidation({
            framework: "bootstrap",
            button: {
                selector: '#btnAddCheck',
                disabled: 'disabled'
            },
            icon: null,
            fields: {
                'CheckAmount': {
                    validators: {
                        notEmpty: {
                            message: 'El monto no puede ser vacío'
                        }
                    }
                },
                'CheckNumber': {
                    validators: {
                        notEmpty: {
                            message: 'El número de cheque no puede ser vacío'
                        }
                    }
                },
                'ReceivedDate': {
                    validators: {
                        notEmpty: {
                            message: 'La fecha recibida no puede ser vacía'
                        }
                    }
                },
                'CheckDueDate': {
                    validators: {
                        notEmpty: {
                            message: 'La fecha de vencimiento no puede ser vacía'
                        }
                    }
                },
                'CheckBank': {
                    validators: {
                        notEmpty: {
                            message: 'El banco no puede ser vacío'
                        }
                    }
                },
                'CheckOwn': {
                    validators: {
                        notEmpty: {
                            message: 'El dueño no puede ser vacío'
                        }
                    }
                }
            }
        });

        var lastCheckId = -1;
        var originalLastCheck = -1;

        

        $(document).ready(function ()
        {
            calculateChargeTotal();
            $(".currency").number(true, 2, ',', '.');

            $('#addCheckButton').click(function () {
                $.ajax({
                    url: '@Url.Action("GetLastCheckIndex", "Checks")',
                    success: function (data, textStatus, jqXHR) {
                        if (lastCheckId == -1) {
                            lastCheckId = data.CheckId + 1;
                        } else {
                            lastCheckId++;
                        }

                        $('#lastCheckId').text(lastCheckId);
                    }
                });
            });

            //Crate Hiddens
            $.each($('.gradeA.check'), function (index, check) {
                addHiddenInputsForCheck(index, $(check));
            });
        });

        $('#checks').on('shown.bs.modal', function () {
            clearModalInputs();
            $('#checksForm').data('formValidation').resetForm();
        });

        function clearModalInputs() {
            $("#bankId").select2({
                placeholder: "Elija un banco",
                allowClear: true
            });

            $("#bankId").select2('val', '');

            $("#checkOwn").select2({
                placeholder: "Elija el dueño",
                allowClear: true
            });

            $("#checkOwn").select2('val', '');
        }


        @if (Model.Checks != null)
        {
            foreach (var check in Model.Checks)
            {
                <text>
            $('#checksTable tr[data-attr-id="' + @check.CheckId + '"]').hide();
                </text>
            }
        }

        $('#checksTable tr[data-attr-id]').click(function () {
            var checksTable = $('#checksTable').dataTable();
            var rowPosition = checksTable.fnGetPosition(this);
            var rowData = checksTable.fnGetData(rowPosition);
            addCheckToPaymentMethods(rowData);
            $(this).hide();
            $('#checks2').modal('hide');
        });

        function addCheckToPaymentMethods(check) {
            var checkId = check[0];
            var id = createColumn(check[0], true);
            var received = createColumn(check[1], true);
            var customer = createColumn(check[2], true);
            var checkNumber = createColumn(check[3], true);
            var bank = createColumn(check[4], true);
            var amount = '<td class="text-center"><span class="checkAmount">' + check[5] + '</span></td>';
            var dueDate = createColumn(check[6], true);
            //var plazo = createColumn(check[7], true);
            var removeCheck = '<td class="text-center"><i class="icon fa-close removeCheck" aria-hidden="true" data-attr-id=' + checkId + ' onclick="removeCheck(this);"></i></td>';

            $('#newChecksTable > tbody:last-child').append('<tr class="paymentMethodCheck" hidden="hidden" data-attr-id=' + checkId + '>' + id + received + checkNumber + bank + amount + dueDate + /*plazo +*/ removeCheck + '</tr>');
            $('.paymentMethodCheck[data-attr-id="' + checkId + '"]').fadeIn();
            updateChecksIds();
            calculateChargeTotal();
        }

        function createColumn(data, center) {
            if (center != undefined) {
                return '<td class="text-center">' + data + '</td>';
            }
            else {
                return '<td>' + data + '</td>';
            }
        }

        function updateChecksIds() {
            var checkIds = $('#ChecksIds');
            var checkIdsArray = [];
            $('.paymentMethodCheck').each(function (c) {
                checkIdsArray.push($(this).data('attr-id'));
            });
            checkIds.val(checkIdsArray.join(','));
        }

        function calculatePaymentOrderTotal() {
            var sum = 0;

            //$('.sumMoney').each(function () {
            //    sum += Number($(this).text().replace('$','').replace(',', '.'));
            //});

            //sum += Number($('#Amount').val().replace(',', '.'));

            $('.checkAmount').each(function () {
                sum += Number($(this).text().split('$').join('').split('.').join('').replace(',', '.'));
            });

            $('#poTotal').text(sum.toLocaleString("es-AR", { style: "currency", currency: "ARS" }));
        }

        $("#btnAddCheck").click(function (e) {
            e.preventDefault();

            var checkForm = $('#checksForm').data('formValidation');

            checkForm.validate();

            if (!checkForm.isValid()) {
                return;
            }

            var rowNumber = $("#newChecksTable tr").length - 1;
            var row =
                '<tr class="gradeA check" data-attr-amount="' + $('#checkAmount').val().replace(".", ",") + '" data-attr-workid="' + $('#checkWorkId').val() + '" data-attr-customerid="' + $('#checkCustomerId').val() + '" data-attr-bankid="' + $('#bankId').val() + '" hidden="hidden" data-attr-rownumber=' + rowNumber + ' data-attr-checkNumber=' + $('#lastCheckId').text() + ' data-attr-checkId="-1" >' +
                    '<td class="checkId text-center">' + $('#lastCheckId').text () + '</td>' +
                    '<td class="receivedDate text-center">' + $('#checkReceivedDate').val() + '</td>' +
                    '<td class="checkNumber text-center">' + $('#checkNumber').val() + '</td>' +
                    '<td class="text-center">' + $('#bankId option:selected').text() + '</td>' +
                    '<td class="checkAmount text-center">$' + $('#checkAmount').val().replace(".", ",") + '</td>' +
                    '<td class="dueDate text-center">' + $('#checkDueDate').val() + '</td>' +
                    '<td class="text-center"><i class="icon fa-close removeCheck" aria-hidden="true" data-attr-id=' + rowNumber + ' onclick="removeCheck(this,' + rowNumber + ');"></i></td>' +
                '</tr>';

            $("#newChecksTable").append(row);

            $('[data-attr-rownumber="' + rowNumber + '').fadeIn();

            calculateChargeTotal();

            $('#checks').modal('toggle');
        });

        $('#btnSave').click(function (e) {
            e.preventDefault();

            $.each($('.gradeA.check'), function (index, check) {
                addHiddenInputsForCheck(index, $(check));
            });

            $('form')[0].submit();
        });

        function addHiddenInputsForCheck(rowNumber, check) {
            addHiddenInput('RecievedDate', rowNumber, check.find('.receivedDate').text());
            addHiddenInput('CheckId', rowNumber, check.attr('data-attr-checkId'));
            addHiddenInput('DueDate', rowNumber, check.find('.dueDate').text());
            addHiddenInput('Amount', rowNumber, check.data('attr-amount'));
            addHiddenInput('Number', rowNumber, check.find('.checkNumber').text());
            addHiddenInput('BankId', rowNumber, check.data('attr-bankid'));
            addHiddenInput('WorkId', rowNumber, check.data('attr-workid'));
            addHiddenInput('CustomerId', rowNumber, check.data('attr-customerid'));
            addHiddenInput('Active', rowNumber, true);
        }

        function addHiddenInput(identifier, rowNumber, value) {
            $('<input>').attr({
                type: 'hidden',
                name: 'Checks[' + rowNumber + '].' + identifier,
                id: 'Checks_' + rowNumber + '__' + identifier,
                class: 'Checks_' + rowNumber,
                value: value
            }).appendTo('form');
        }

        function removeCheck(check, rowNumber) {
            var checkId = $(check).data('attr-id');
            var checkRow = $(check).parent().parent();

            $("input[name*='Checks[" + rowNumber + "].Active']").val(false);

            checkRow.fadeOut("slow", function () {
                checkRow.remove();
                /*$('.Checks_' + rowNumber).each(function () {
                    $(this).remove();
                });*/
                calculateChargeTotal();
            });
        }

        function calculateChargeTotal() {
            var sum = 0;

            $('.sumMoney').each(function () {
                sum += Number($(this).val().replace(',', '.'));
            });

            $('.checkAmount').each(function () {
                sum += Number($(this).text().split('$').join('').split('.').join('').replace(',', '.'));
            });

            $('#cgTotal').text(sum.toLocaleString("es-AR", { style: "currency", currency: "ARS" }));
        }

    </script>
}

